package com.sa.ibiz.demo.demo.rest;

import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.sa.ibiz.demo.demo.domain.WFWorkflow;
import com.sa.ibiz.demo.demo.service.WFWorkflowService;
import com.sa.ibiz.demo.demo.service.dto.WFWorkflowSearchFilter;
import com.sa.ibiz.demo.ibizutil.errors.BadRequestAlertException;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.http.ResponseEntity;
import org.springframework.validation.annotation.Validated;
import org.springframework.web.bind.annotation.*;
import java.math.BigInteger;
import java.util.List;

@RestController
@RequestMapping("/demo/wfworkflow")
public class WFWorkflowResource
{
	@Autowired
	private WFWorkflowService service;


	@PostMapping(value = "/create")
	public ResponseEntity<WFWorkflow> create(@Validated @RequestBody WFWorkflow data){
		boolean bRt=service.create(data);
		if(!bRt)
			throw new BadRequestAlertException("工作流配置[create]操作发生错误","WFWorkflow",data.getWfworkflowid().toString());
		return ResponseEntity.ok().body(data);
	}
	@PostMapping(value = "/remove")
	public ResponseEntity<WFWorkflow> remove(@Validated @RequestBody WFWorkflow data){
		boolean bRt=service.remove(data);
		if(!bRt)
			throw new BadRequestAlertException("工作流配置[remove]操作发生错误","WFWorkflow",data.getWfworkflowid().toString());
		return ResponseEntity.ok().body(data);
	}
	@PostMapping(value = "/checkKey")
	public ResponseEntity<WFWorkflow> checkKey(@Validated @RequestBody WFWorkflow data){
		boolean bRt=service.checkKey(data);
		if(!bRt)
			throw new BadRequestAlertException("工作流配置[checkKey]操作发生错误","WFWorkflow",data.getWfworkflowid().toString());
		return ResponseEntity.ok().body(data);
	}
	@GetMapping(value = "/{id}")
	public ResponseEntity<WFWorkflow> get(@Validated @PathVariable String id){
		WFWorkflow data=new WFWorkflow();
		data.setWfworkflowid(id);;
		data=service.get(data);
		if(data==null)
			throw new BadRequestAlertException("工作流配置[get]操作发生错误","WFWorkflow",id.toString());
		return ResponseEntity.ok().body(data);
	}
	@PostMapping(value = "/getDraft")
	public ResponseEntity<WFWorkflow> getDraft(@Validated @RequestBody WFWorkflow data){
		boolean bRt=service.getDraft(data);
		if(!bRt)
			throw new BadRequestAlertException("工作流配置[getDraft]操作发生错误","WFWorkflow","");
		return ResponseEntity.ok().body(data);
	}
	@PostMapping(value = "/update")
	public ResponseEntity<WFWorkflow> update(@Validated @RequestBody WFWorkflow data){
		boolean bRt=service.update(data);
		if(!bRt)
			throw new BadRequestAlertException("工作流配置[update]操作发生错误","WFWorkflow",data.getWfworkflowid().toString());
		return ResponseEntity.ok().body(data);
	}
    @PostMapping(value="/searchdefault")
	public ResponseEntity<Page<WFWorkflow>> searchDefaultPage(@Validated @RequestBody WFWorkflowSearchFilter filter){
		Page<WFWorkflow> searchResult = service.searchDefault(filter);
		return ResponseEntity.ok().body(searchResult);
	}

	@PostMapping(value="/listdefault")
	public ResponseEntity<List<WFWorkflow>> listDefault(@Validated @RequestBody WFWorkflowSearchFilter filter){
		List<WFWorkflow> searchResult = service.listDefault(filter);
		return ResponseEntity.ok().body(searchResult);
	}
}
